---
title: XRWebGLLayer.ignoreDepthValues
slug: Web/API/XRWebGLLayer/ignoreDepthValues
tags:
  - 3D
  - API
  - AR
  - Depth
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebGL
  - WebGL API
  - WebGL Device API
  - XR
  - XRWebGLLayer
  - augmented
  - ignoreDepthValues
---
<p>{{securecontext_header}}{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRWebGLLayer")}} property <strong><code>ignoreDepthValues</code></strong> is a Boolean value which is <code>true</code> if the session has been configured to ignore the values in the depth buffer while rendering the scene. If the depth buffer is being used to determine the position of vertices, this property is <code>false</code>.</span></p>

<p>The value of <code>ignoreDepthValues</code> can only be set when the {{domxref("XRWebGLLayer")}} is instantiated, by setting the corresponding value in the {{domxref("XRWebGLLayerInit")}} object specified as the <a href="/en-US/docs/Web/API/XRWebGLLayer/XRWebGLLayer">constructor's</a> <code>layerInit</code> parameter. As a parameter you're likely to set yourself, it is unlikely you'll need to read it later, but it's available if the need arises.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>ignoringDepthBuffer</em> = <em>xrWebGLLayer</em>.ignoreDepthValues;</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value which is <code>true</code> if the WebGL context's depth buffer is being used while computing the locations of points in the 3D world. Otherwise, if this is <code>true</code>, the depth buffer's values are being used to assist in placing objects in the scene. Since the <a href="/en-US/docs/Web/API/WebXR_Device_API/Fundamentals#The_WebXR_compositor">XR compositor</a> uses the depth buffer by default, this value is <code>false</code> unless explicitly set otherwise when creating the {{domxref("XRWebGLLayer")}} using its constructor, {{domxref("XRWebGLLayer.XRWebGLLayer", "XRWebGLLayer()")}}.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>When the <code>ignoreDepthValues</code> property is <code>false</code>, the XR compositor uses the values found in the depth buffer, which should be accurate for the scene, in order to potentially improve the quality or the output as well as the comfort level for the viewer.</p>

<p>The depth buffer is {{domxref("XRWebGLLayer.framebufferWidth", "framebufferWidth")}} entires wide and {{domxref("XRWebGLLayer.framebufferHeight", "framebuffer")}} entries tall. Each entry in the buffer specifies the depth at which the corresponding pixel is located, and has a value between 0.0 and 1.0.</p>

<p>A depth buffer pixel value of 0.0 corresponds to the depth given by the session's {{domxref("XRRenderState.depthNear", "depthNear")}} and a value of 1.0 corresponds to the depth given by {{domxref("XRRenderState.depthFar", "depthFar")}}.</p>

<p>The depth, in tandem with the coordinates of each point being rendered, makes it possible to more accurately represent the scene in the 3D space.</p>

<h2 id="Examples">Examples</h2>

<p>If the Web application which is using WeXR is rendering its content without using a depth buffer—or if the depth buffer's contents are invalid—you should disable the use of the depth buffer for WebXR rendering by setting <code>ignoreDepthValues</code> to true when creating the {{domxref("XRWebGLLayer")}}. This is demonstrated in the snippet of code below:</p>

<pre class="brush: js">const glLayerOptions = {
  ignoreDepthValues: true
};

let glLayer = new XRWebGLLayer(xrSession, gl, glLayerOptions);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayer-ignoredepthvalues','XRWebGLLayer.ignoreDepthValues')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayer.ignoreDepthValues")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li>{{domxref("WebGLLayerInit")}}</li>
 <li>WebGL depth buffer related methods: {{domxref("WebGLRenderingContext.depthFunc", "depthFunc()")}}, {{domxref("WebGLRenderingContext.clearDepth", "clearDepth()")}}</li>
</ul>
